%{
#include "parser.h"
%}
TIRNAK \"
BIRKARAKTER .
TERSTAKSIM \\
KACMAKARAKTER {TERSTAKSIM}{BIRKARAKTER}
NORMALKARAKTER [^\\"\b\f\n\r\t]
KARAKTER {NORMALKARAKTER}|{KACMAKARAKTER}
KARAKTERLER {KARAKTER}+
ONDALIK [.]
POZITIFRAKAM [1-9]
SIFIR 0
RAKAM {SIFIR}|{POZITIFRAKAM}
E     [eE]
EXP   {E}[-+]?{RAKAM}+
FRAC  {ONDALIK}{RAKAM}+
INT   {SIFIR}|{POZITIFRAKAM}{RAKAM}*
%%
{TIRNAK}{TIRNAK}|{TIRNAK}{KARAKTERLER}{TIRNAK} { return T_STRING; }
[-]?{INT}{FRAC}?{EXP}?			{ return T_NUMBER; }
":"	{ return ':'; }
","	{ return ','; }
"{"	{ return '{'; }
"}"	{ return '}'; }
"["	{ return '['; }
"]"	{ return ']'; }
"null"  { return T_NULL; }
"true"   { return T_TRUE; }
"false"  { return T_FALSE; }
[ \t\n\r]+ { /* ignore */ }
%%
int yywrap() {
	return 1;
}
